<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Crytography Exercise</title>
        <style>
          .plain {color: indigo }
          .cipher {color: red; font-size: large }
          .notcipher {background-color: gray }
          .courier {font-family: monospace; font-size: large}
          .contrast { background-color: yellow; font-weight: bold }
        </style>
    </head>
    <body>
<?php
	ini_set("display_errors", 1);
	$info = "/home/mps/private/vigenere-info.php";
	include $info;
?>

<h1>Encrypting Data using the Vigen&egrave;re Cipher</h1>
Enter a secret key and some plain text in this form, then click the button to see the associated cipher text. You will then be asked to confirm whether you wish to submit this as your challenge. The form will let you enter any characters you want, but it will only use alphabetic characters for encrypting. Your key can contain other characters, but the script will ignore them. 
<p></p>
<font color=darkred><b>Your message should be between <?php echo $minLength; ?> and <?php echo $maxLength; ?> alphabetic characters long, and can also contain basic punctuation (including 'single', but not "double", quotes).</b></font>


<?php
$key = isset($_REQUEST{'key'}) ? $_REQUEST{'key'} : "";
$msg = isset($_REQUEST{'msg'}) ? $_REQUEST{'msg'} : "";
$team = isset($_REQUEST{'team'}) ? $_REQUEST{'team'} : "";

$msglen = strlen(txtOnlyUpper($msg));
$ready = $key && $msg
         && ($msglen >= $minLength) 
		 && ($msglen <= $maxLength);

if ($ready) {
	$vkey = validateTxt($key);
	$vmsg = validateTxt($msg);
	$ciph = encrypt($vkey,$vmsg);
}
?>

<blockquote>
<div>
<form name="getKey" action="vigenere.php" method="post">
<table cellpadding="4" border="1">
<tr>
	<td align="right">Your Secret Key:</td>
	<td><input name="key" type="text" value="<?php echo $key; ?>" size="120" maxlength="180" /></td>
</tr>
<tr>
	<td align="right">Your Plain Text:</td>
	<td><input name="msg" type="text"  value="<?php echo $msg; ?>" size="120" maxlength="180" /></td>
</tr>
<tr><td colspan="2" align="center"><input value="Calculate <?php 
		if (strlen($key)) { echo "A Different "; };
	?>Cipher Text" type="submit"/></td></tr>
</table>
</form>
<?php
  if ($msglen < $minLength) {
?>
	</blockquote>
	<h2>Sorry!</h2>
	<blockquote>
	Your message is too short. It only contains <?php echo $msglen; ?> alphabetic characters.
	Your message should be between <?php echo $minLength; ?> and <?php echo $maxLength; ?> alphabetic characters long.
<?php } else if ($msglen > $maxLength) { ?>
	</blockquote>
	<h2>Sorry</h2>
	<blockquote>
	Sorry - your message is too long. It currently contains <?php echo $msglen; ?> alphabetic characters.
	Your message should be between <?php echo $minLength; ?> and <?php echo $maxLength; ?> alphabetic characters long.
<?php } ?>
</div>
</blockquote>

<?php if($ready) { ?>
<h2>Your cipher text</h2>
<blockquote>
<p>Your message contains <?php echo $msglen; ?> alphabetic characters.</p>
<div>
<table cellpadding="3" border="1">
	<tr><td align="right">Plain Text:</td>
	    <td class="courier plain"><?php
			echo strtoupper($msg); 
			?></td></tr>
	<tr><td align="right">Key:</td>
	    <td class="courier plain"><?php
			echo txtOnlyUpper($key); 
			?></td></tr>
	<tr><td align="right">Cipher Text:</td>
	    <td class="courier cipher"><?php
			echo implode(matchNonAlphas()); 
			?></td></tr>
</table>
</div>
<br />
<div>

<p>If you are ready to submit this as your challenge, tell me your team name and
click the button below. Otherwise, choose a new message and/or key above and calculate another cipher
text.<p>
<blockquote><form action="confirmChallenge.php" method="post" 
	onSubmit="if (teamname.value.length > 0) return true; alert('Please provide a team name!'); return false;")">
<input type="hidden" name="plaintext" value="<?php echo strtoupper($msg); ?>">
<input type="hidden" name="secretkey" value="<?php echo txtOnlyUpper($key); ?>">
<input type="hidden" name="ciphertext" value="<?php echo implode(matchNonAlphas()); ?>">
<table cellpadding="3" border="1" background="yellow" bordercolor="red">
<tr><td>Your Team Name</td><td><input name="teamname" size=80 maxlength=120></td></tr>
<tr><td colspan="2">
	<center><input type="submit" value="Submit this as your challenge"></center>
</td></tr>
</table>
</form></blockquote>
</blockquote>

<h2>How we calculated this</h2>
<blockquote>
<table cellpadding="1" border="1">

<?php
	makeHeaderRow();
	showCipherText($vkey,$vmsg);
?>
</table>
</div>
</blockquote>
<?php } ?>
</body>
</html>
