<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Crytography Exercise</title>
        <style>
          .plain {color: blue; font-size: large }
          .cipher {color: red; font-size: large }
          .courier {font-family: monospace}
          .contrast { background-color: yellow; font-weight: bold }
          td { text-align: center }
        </style>
    </head>
    <body>

<?php
	// put your code here
$letters = range('A', 'Z');

function makeHeaderRow() {
	global $letters;
	echo "<tr><td>&nbsp;</td>";
	for ($a=0; $a<26; $a++) {
		$ch = $letters[$a];
		echo "<th class=\"contrast courier plain\">$ch</th>";
	}
	echo "</tr>";
}

function makeRow($offset, $highlight) {
	global $letters;
	// draw a row of upper-case letters, starting at letter 
	// A+$offset. We treat A as letter 0, through to Z as 
	// letter 25. No other characters will be included.
	// After reaching Z, we cycle back to A. The input is
	// pre-validated to ensure we have uppercase letters.
	echo "<th class=\"contrast courier cipher\">$letters[$offset]</th>";
	for ($a=0; $a<26; $a++) {
		$ch = $letters[($a+$offset)%26];
		if ($highlight == $a) {
			echo "<td class=\"contrast courier cipher\">$ch</td>";
		}
		else {
			echo "<td>$ch</td>";
		}
	}
}

// Validate key and convert to array
function validateTxt($key) {
	$result = array();
	$upper = strtoupper($key);
	$temp = str_split($upper);
	for ($n=0; $n<count($temp); $n++ ) {
		$test = $temp[$n];
		$ord = ord($test) - ord('A');
		if ($ord >= 0 && $ord < 26) {
			array_push($result, $test);
		}
	}
	return $result;
}

function addChars($k, $m) {
	$aord = ord('A');
	$kord = ord($k) - $aord;
	$mord = ord($m) - $aord;
	$result = chr( ($kord+$mord)%26 + $aord );
	return $result;
}

function encrypt() {
	global $vkey, $vmsg;
	$lkey = count($vkey);
	$lmsg = count($vmsg);

	$result = array();
	for ($n=0; $n<$lmsg; $n++) {
		$k = $vkey[$n%$lkey];
		$m = $vmsg[$n%$lmsg];
		$c = ($m === ' ') ? ' ' : addChars($k, $m);
    array_push($result,$c);
	}
	return $result;
}

function showCipherText() {
	global $vkey, $vmsg, $ciph;
	$klen = count($vkey);
	for ($n=0; $n<count($ciph); $n++) {
		$k = $vkey[$n%$klen];
		$offset = ord($k) - ord('A');
		$highlight = ord($vmsg[$n]) - ord('A');
		echo "<tr>";
		makeRow($offset, $highlight);
		echo "<td></td>"
       . "<td class=\"courier plain\">$vmsg[$n]</td>"
       . "<td class=\"courier cipher\">$ciph[$n]</td>";
		echo "</tr>";
	}
}

function matchNonAlphas() {
	global $msg, $ciph;
	$result = array();
	$mup = strtoupper($msg);
	$cpos = 0;
	for ($n=0; $n < strlen($msg); $n++) {
		$m = $mup[$n];
		$offset = ord($m) - ord('A');
		if ( $offset < 0 || $offset > 25) {
			$result[$n] = $msg[$n];
		}
		else {
			$result[$n] = $ciph[$cpos];
			$cpos++;
		}
	}
	return $result;
}


$key = isset($_REQUEST{'key'}) ? $_REQUEST{'key'} : "";
$msg = isset($_REQUEST{'msg'}) ? $_REQUEST{'msg'} : "";

$vkey = validateTxt($key);
$vmsg = validateTxt($msg);
$ciph = encrypt($vkey,$vmsg);

?>

<div>
<form name="getKey" action="vigenere-only.php" method="get">
<table cellpadding="4" border="1">
<tr>
	<td align="right">Enter key:</td>
	<td><input name="key" type="text" size="120" maxlength="120" /></td>
</tr>
<tr>
	<td align="right">Message:</td>
	<td><input name="msg" type="text" size="120" maxlength="180" /></td>
</tr>
<tr><td colspan="2"><input type="submit" /></td></tr>
</table>
</form>
</div>

<div>
<table cellpadding="3" border="1">
	<tr><td align="right">Plain:</td>
	    <td class="courier plain"><?php
			echo strtoupper($msg); 
			?></td></tr>
	<tr><td align="right">Cipher:</td>
	    <td class="courier cipher"><?php
			echo implode(matchNonAlphas()); 
			?></td></tr>
</table>
</div>

<br />

<div>
<table cellpadding="1" border="1">
<?php
	makeHeaderRow();
	showCipherText($vkey,$vmsg);
?>
</table>
</div>

</body>
</html>
